package org.meandre.tools.serialization.xstream;

import org.junit.Test;

import com.thoughtworks.xstream.XStream;


public class XStreamSerializationTest {

	@Test
	public void testXStreamSerialization () {
		XStream xstream = new XStream();
		final int MAX_SIZE = 10000;
		final int REP = 50;
		final int INC = 100;
		
		System.out.println("XStream serialization times");
		for ( int i=INC ; i<=MAX_SIZE ; i+=INC ) {
			TargetObject to = new TargetObject(i,i);
			long lAccTime = 0;
			long lSize = 0;
			long lTmp;
			String sTmp;
			for ( int j=0 ; j<REP ; j++ ) {
				lTmp = System.currentTimeMillis();
				sTmp = xstream.toXML(to);
				lTmp -= System.currentTimeMillis();
				lAccTime -= lTmp;
				lSize = sTmp.getBytes().length; 
			}
			System.out.println(""+i+"\t"+(((double)lAccTime)/REP)+"\t"+lSize);
		}
	}


	@Test
	public void testXStreamDeserialization () {
		XStream xstream = new XStream();
		final int MAX_SIZE = 10000;
		final int REP = 50;
		final int INC = 100;
		
		System.out.println("XStream deserialization times");
		for ( int i=INC ; i<=MAX_SIZE ; i+=INC ) {
			TargetObject to = new TargetObject(i,i);
			String sSerializedTO = xstream.toXML(to);
			long lAccTime = 0;
			long lTmp;
			for ( int j=0 ; j<REP ; j++ ) {
				lTmp = System.currentTimeMillis();
				xstream.fromXML(sSerializedTO);
				lTmp -= System.currentTimeMillis();
				lAccTime -= lTmp;
			}
			System.out.println(""+i+"\t"+(((double)lAccTime)/REP));
		}
	}
}
